--local frame = CreateFrame("Frame", "BTBMainFrame", UIParent)
local threatbar = CreateFrame("StatusBar", "ThreatBar", UIParent)
threatbar:SetHeight(35)
threatbar:SetWidth(200)
threatbar:SetPoint("CENTER", UIParent, "CENTER", 0, 0)
threatbar:EnableMouse(true)
threatbar:SetMovable(true)
threatbar:SetResizable(true)
threatbar:SetUserPlaced(true)
threatbar:SetClampedToScreen( true )
threatbar:SetMaxResize(500,125);
threatbar:SetMinResize(125,16);
threatbar:RegisterForDrag("LeftButton");
threatbar:SetScript("OnDragStart", function(s) 
	if IsAltKeyDown() then s:StartMoving() 
	elseif IsShiftKeyDown() then s:StartSizing()
	end 
end)
threatbar:SetScript("OnDragStop", function(s) s:StopMovingOrSizing() end)
threatbar:SetScript("OnEnter", function(s) 
	if not UnitAffectingCombat("player") then
		GameTooltip:SetOwner(s, "ANCHOR_TOP")
        GameTooltip:AddLine("Basic Threat Bar", 0, 1, 0.5, 1, 1, 1)
        GameTooltip:AddLine("Hold down SHIFT to resize.", 1, 1, 1, 1, 1, 1)
		GameTooltip:AddLine("Hold down ALT to move.", 1, 1, 1, 1, 1, 1)
        GameTooltip:AddLine("Type /btb hide to hide bar out of combat.", 1, 1, 1, 1, 1, 1)
		GameTooltip:AddLine("Type /btb show to leave visible.", 1, 1, 1, 1, 1, 1)
		GameTooltip:AddLine("Right click for configuration.", 1, 1, 1, 1, 1, 1)
		GameTooltip:Show()
	end
end)
threatbar:SetScript("OnLeave", function(s)
GameTooltip:Hide()
end)

threatbar:RegisterEvent("UNIT_THREAT_SITUATION_UPDATE")
threatbar:RegisterEvent("UNIT_THREAT_LIST_UPDATE")
threatbar:RegisterEvent("PLAYER_TARGET_CHANGED")
threatbar:RegisterEvent("PARTY_MEMBERS_CHANGED")
threatbar:RegisterEvent("PLAYER_LOGIN")


--threatbar:SetPoint("TOPLEFT", frame, "TOPLEFT", 3, -3)
--threatbar:SetPoint("BOTTOMRIGHT", frame, "BOTTOMRIGHT", -3, 3)
--threatbar:SetHeight(25)
--threatbar:SetWidth(190)

threatbar:SetMinMaxValues(0, 100)
threatbar:SetValue(0)
threatbar:SetBackdrop({ 
	bgFile = "Interface\\Tooltips\\UI-Tooltip-Background",
	insets = {left = -3, right = -3, top = -3, bottom = -3}
})
threatbar:SetBackdropColor(0, 0, 0, .45)

local font1 = threatbar:CreateFontString("UnitName", "ARTWORK", "GameFontNormal")
font1:SetPoint("TOP", threatbar, "TOP", 0, 15)

local font2 = threatbar:CreateFontString("Percent", "OVERLAY", "GameFontNormal")
font2:SetPoint("CENTER", threatbar, "CENTER")
font2:SetTextColor(1, 1, 1)

--[[local icon = threatbar:CreateTexture("Icon", "OVERLAY")
icon:SetTexture("Interface\\LFGFrame\\UI-LFG-ICON-PORTRAITROLES")
icon:SetTexCoord(GetTexCoordsForRoleSmallCircle("TANK"))
icon:SetPoint("TOPLEFT", threatbar, "TOPLEFT")
icon:SetHeight(16)
icon:SetWidth(16)]]


SLASH_ThreatBar1 = "/btb";
local function handler(msg, editbox)
	if (msg=="show") then
		threatbar:Show()
		hidden = nil
	elseif (msg=="hide") then
		threatbar:Hide()
		hidden = true
	--[[elseif (msg=="lock") then
	frame:EnableMouse(nil)
	frame:SetMovable(nil)
	frame:SetResizable(nil)
	frame:SetScript("OnEnter", nil)
	frame:SetScript("OnLeave", nil)]]
	end
end
SlashCmdList["ThreatBar"] = handler;


local function GetThreat(unitId, mobId)
	local _, _, threatpct, _, _ = UnitDetailedThreatSituation(unitId, mobId)
	if not threatpct then threatpct = 0 end
	return floor(threatpct)
end

local function GetThreatStatus(unitId, mobId)
	local _,status,_,_, _ = UnitDetailedThreatSituation(unitId, mobId)
	return status
end

local function GetTank(unitId, mobId)
	local isTanking,_,_,_, _ = UnitDetailedThreatSituation(unitId, mobId)
	if not isTanking then isTanking = 0 end
	return isTanking
end

local function GetThreatValue(unitId, mobId)
	local _, _, _, _, threatvalue = UnitDetailedThreatSituation(unitId, mobId)
	if not threatvalue then threatvalue = 0 end
	return threatvalue
end

local function GetClassColor(unit)
	local unitClass, englishClass = UnitClass(unit)
	local classColor = "ff848484" --Pets
	if englishClass == "DEATHKNIGHT" then
		classColor = "ffC41F3B"
		
	elseif englishClass == "DRUID" then
		classColor = "ffFF7D0A"
	
	elseif englishClass == "HUNTER" then
		classColor = "ffABD473"
	
	elseif englishClass == "MAGE" then
		classColor = "ff69CCF0"
	
	elseif englishClass == "PALADIN" then
		classColor = "ffF58CBA"
	
	elseif englishClass == "PRIEST" then
		classColor = "ffFFFFFF"
	
	elseif englishClass == "ROGUE" then
		classColor = "ffFFF569"
	
	elseif englishClass == "SHAMAN" then
		classColor = "ff2459FF"
	
	elseif englishClass == "WARLOCK" then
		classColor = "ff9482C9"
	
	elseif englishClass == "WARRIOR" then
		classColor = "ffC79C6E"
	end
	return classColor
end

local function UpdateDisplay()
	font1:SetText("")
	font2:SetText("")
	--icon:Hide()
	threatbar:SetValue(0)
	threatbar:SetBackdropColor(0, 0, 0, .45)
	--frame:SetBackdropBorderColor(0, 0, 0, 1)
	local status = nil
	local highUnit = ""
	local unitThreat = 0
	local highThreat = 0
	local tankName = nil
	local unitThreatValue = 0
	local playerThreatValue = 0
	local partynum = GetNumPartyMembers()
	local raidnum = GetNumRaidMembers()
	if hidden == true then -- hide frame
		threatbar:Hide()
	end
	if (partynum == 0 and raidnum == 0) and UnitCanAttack("player", "target") and not(UnitIsDead("target") or UnitIsFriend("player", "target") or UnitPlayerControlled("target")) -- Solo Target
	then			
		status = GetThreatStatus("player", "target")
		threatpct = GetThreat("player", "target")
		playerThreatValue = GetThreatValue("player", "target")
		if HasPetUI() then
			unitThreatValue = GetThreatValue("pet", "target")
			highThreat = GetThreat("pet", "target")
			highUnit = UnitName("pet")
			highUnitColor = GetClassColor("pet")
			unitTanking = GetTank("pet", "target")
			if unitTanking == 1 then
				unitTankingColor = GetClassColor("pet")
				tankName = UnitName("pet")
			end
		end
	elseif (partynum == 0 and raidnum == 0) and UnitCanAttack("player", "targettarget") and not (UnitCanAttack("player", "target") or UnitIsDead("targettarget") or UnitIsFriend("player", "targettarget") or UnitPlayerControlled("targettarget")) -- Solo Target of Target
	then
		status = GetThreatStatus("player", "targettarget")
		threatpct = GetThreat("player", "targettarget")
		playerThreatValue = GetThreatValue("player", "targettarget")
		if HasPetUI() then
			unitThreatValue = GetThreatValue("pet", "targettarget")
			highThreat = GetThreat("pet", "targettarget")
			highUnit = UnitName("pet")
			highUnitColor = GetClassColor("pet")
			unitTanking = GetTank("pet", "targettarget")
			if unitTanking == 1 then
				unitTankingColor = GetClassColor("pet")
				tankName = UnitName("pet")
			end
		end
	elseif (raidnum > 0) and UnitCanAttack("player", "target") and not (UnitIsDead("target") or UnitIsFriend("player", "target") or UnitPlayerControlled("target")) --Raid Target
	then 
		status = GetThreatStatus("player", "target")
		threatpct = GetThreat("player", "target")
		playerThreatValue = GetThreatValue("player", "target")
		for i = 1, (raidnum -1) do
			unitThreat = GetThreat("raid"..i, "target") 	
				if unitThreat > highThreat then 
					highThreat = unitThreat	
					highUnit = UnitName("raid"..i)
					highUnitColor = GetClassColor("raid"..i)
					unitThreatValue = GetThreatValue("raid"..i, "target")
				end
			unitThreat = GetThreat("raidpet"..i, "target")	
				if unitThreat > highThreat then 
					highThreat = unitThreat	
					highUnit = UnitName("raidpet"..i)
					highUnitColor = GetClassColor("pet")
					unitThreatValue = GetThreatValue("raidpet"..i, "target")
				end
			unitThreat = GetThreat("pet", "target")
				if unitThreat > highThreat then
					highThreat = unitThreat
					highUnit = UnitName("pet")
					highUnitColor = GetClassColor("pet")
					unitThreatValue = GetThreatValue("pet", "target")
				end
			unitTanking = GetTank("raid"..i, "target")
			if unitTanking == 1 then
				unitTankingColor = GetClassColor("raid"..i)
				tankName = UnitName("raid"..i)
			end
			unitTanking = GetTank("raidpet"..i, "target")
			if unitTanking == 1 then
				unitTankingColor = GetClassColor("raidpet"..i)
				tankName = UnitName("raidpet"..i)
			end
			unitTanking = GetTank("pet", "target")
			if unitTanking == 1 then
				unitTankingColor = GetClassColor("pet")
				tankName = UnitName("pet")
			end
		end
	elseif (raidnum > 0) and UnitCanAttack("player", "targettarget") and not (UnitCanAttack("player", "target") or UnitIsDead("targettarget") or UnitIsFriend("player", "targettarget") or UnitPlayerControlled("targettarget")) --Raid Target of Target
	then
		status = GetThreatStatus("player", "targettarget")
		threatpct = GetThreat("player", "targettarget")	
		playerThreatValue = GetThreatValue("player", "targettarget")
		for i = 1, (raidnum -1) do
			unitThreat = GetThreat("raid"..i, "targettarget") 	
				if unitThreat > highThreat then 
					highThreat = unitThreat	
					highUnit = UnitName("raid"..i)
					highUnitColor = GetClassColor("raid"..i)
					unitThreatValue = GetThreatValue("raid"..i, "targettarget")
				end
			unitThreat = GetThreat("raidpet"..i, "targettarget")	
				if unitThreat > highThreat then 
					highThreat = unitThreat	
					highUnit = UnitName("raidpet"..i)
					highUnitColor = GetClassColor("pet")
					unitThreatValue = GetThreatValue("raidpet"..i, "targettarget")
				end
			unitThreat = GetThreat("pet", "targettarget")
				if unitThreat > highThreat then
					highThreat = unitThreat
					highUnit = UnitName("pet")
					highUnitColor = GetClassColor("pet")
					unitThreatValue = GetThreatValue("pet", "targettarget")
				end
			unitTanking = GetTank("raid"..i, "targettarget")
			if unitTanking == 1 then
				unitTankingColor = GetClassColor("raid"..i)
				tankName = UnitName("raid"..i)
			end
			unitTanking = GetTank("raidpet"..i, "targettarget")
			if unitTanking == 1 then
				unitTankingColor = GetClassColor("raidpet"..i)
				tankName = UnitName("raidpet"..i)
			end
			unitTanking = GetTank("pet", "targettarget")
			if unitTanking == 1 then
				unitTankingColor = GetClassColor("pet")
				tankName = UnitName("pet")
			end
		end
	elseif (partynum > 0) and UnitCanAttack("player", "target") and not (UnitIsDead("target") or UnitIsFriend("player", "target") or UnitPlayerControlled("target")) -- Party Target
	then 
		status = GetThreatStatus("player", "target")
		threatpct = GetThreat("player", "target")
		playerThreatValue = GetThreatValue("player", "target")
		for i = 1, partynum do
			unitThreat = GetThreat("party"..i, "target") 	
				if unitThreat > highThreat then 
					highThreat = unitThreat	
					highUnit = UnitName("party"..i)
					highUnitColor = GetClassColor("party"..i)
					unitThreatValue = GetThreatValue("party"..i, "target")
				end
			unitThreat = GetThreat("partypet"..i, "target")	
				if unitThreat > highThreat then 
					highThreat = unitThreat	
					highUnit = UnitName("partypet"..i)
					highUnitColor = GetClassColor("partypet"..i)
					unitThreatValue = GetThreatValue("partypet"..i, "target")
				end
			unitThreat = GetThreat("pet", "target")
				if unitThreat > highThreat then
					highThreat = unitThreat
					highUnit = UnitName("pet")
					highUnitColor = GetClassColor("pet")
					unitThreatValue = GetThreatValue("pet", "target")
				end
			unitTanking = GetTank("party"..i, "target")
			if unitTanking == 1 then
				unitTankingColor = GetClassColor("party"..i)
				tankName = UnitName("party"..i)
			end
			unitTanking = GetTank("partypet"..i, "target")
			if unitTanking == 1 then
				unitTankingColor = GetClassColor("partypet"..i)
				tankName = UnitName("partypet"..i)
			end
			unitTanking = GetTank("pet", "target")
			if unitTanking == 1 then
				unitTankingColor = GetClassColor("pet")
				tankName = UnitName("pet")
			end
		end
	elseif (partynum > 0) and UnitCanAttack("player", "targettarget") and not (UnitCanAttack("player", "target") or UnitIsDead("targettarget") or UnitIsFriend("player", "targettarget") or UnitPlayerControlled("targettarget")) --Party Target of Target
	then
		status = GetThreatStatus("player", "targettarget")
		threatpct = GetThreat("player", "targettarget")
		playerThreatValue = GetThreatValue("player", "targettarget")
		for i = 1, partynum do
			unitThreat = GetThreat("party"..i, "targettarget") 	
				if unitThreat > highThreat then 
					highThreat = unitThreat	
					highUnit = UnitName("party"..i)
					highUnitColor = GetClassColor("party"..i)
					unitThreatValue = GetThreatValue("party"..i, "targettarget")
				end
			unitThreat = GetThreat("partypet"..i, "targettarget")	
				if unitThreat > highThreat then 
					highThreat = unitThreat	
					highUnit = UnitName("partypet"..i)
					highUnitColor = GetClassColor("partypet"..i)
					unitThreatValue = GetThreatValue("partypet"..i, "targettarget")
				end
			unitThreat = GetThreat("pet", "targettarget")
				if unitThreat > highThreat then
					highThreat = unitThreat
					highUnit = UnitName("pet")
					highUnitColor = GetClassColor("pet")
					unitThreatValue = GetThreatValue("pet", "targettarget")
				end
			unitTanking = GetTank("party"..i, "targettarget")
			if unitTanking == 1 then
				unitTankingColor = GetClassColor("party"..i)
				tankName = UnitName("party"..i)
			end
			unitTanking = GetTank("partypet"..i, "targettarget")
			if unitTanking == 1 then
				unitTankingColor = GetClassColor("partypet"..i)
				tankName = UnitName("partypet"..i)
			end
			unitTanking = GetTank("pet", "target")
			if unitTanking == 1 then
				unitTankingColor = GetClassColor("pet")
				tankName = UnitName("pet")
			end
		end
	end
	if status then -- show frame
		--icon:Show()
		if hidden == true and not threatbar:IsShown() then
			threatbar:Show()
		end
	end
	if status == 0
	then
		--icon:SetTexCoord(GetTexCoordsForRoleSmallCircle("DAMAGER"))
		font2:SetText(string.format("%d %%", threatpct ))
		threatbar:SetValue(threatpct)
		threatbar:SetStatusBarColor(0, 1, 0, 1)
		--frame:SetBackdropBorderColor(0, 1, 0, 1)
		if tankName
		then
			threatValuediff = ((unitThreatValue - playerThreatValue) / 100000 )
			font1:SetText(string.format("|c%s%s|r", unitTankingColor, tankName ))
			font2:SetText(string.format("%2.1fk | %d %%", threatValuediff, threatpct ))
			threatbar:SetValue(threatpct)
		end
	elseif status == 1
	then
		--icon:SetTexCoord(GetTexCoordsForRoleSmallCircle("DAMAGER"))
		font2:SetText(string.format("%d %%", threatpct ))
		threatbar:SetValue(threatpct)
		threatbar:SetStatusBarColor(1, 1, 0, 1)
		--frame:SetBackdropBorderColor(1, 1, 0, 1)
		if tankName
		then
			threatValuediff = ((unitThreatValue - playerThreatValue) / 100000 )
			font1:SetText(string.format("|c%s%s|r", unitTankingColor, tankName ))
			font2:SetText(string.format("%2.1fk | %d %%", threatValuediff, threatpct ))
			threatbar:SetValue(threatpct)
		end
	elseif status == 2
	then
		--icon:SetTexCoord(GetTexCoordsForRoleSmallCircle("TANK"))
		font2:SetText("WEAK AGGRO!")
		threatbar:SetValue(threatpct)
		threatbar:SetStatusBarColor(1, .5, 0, 1)
		--frame:SetBackdropBorderColor(1, .5, 0, 1)
		if highThreat ~= 0
		then
			threatValuediff = ((playerThreatValue - unitThreatValue) / 100000 )
			threatdiff = (100 - highThreat)
			font1:SetText(string.format("|c%s%s|r", highUnitColor, highUnit ))
			font2:SetText(string.format("%2.1fk | %s %%", threatValuediff, threatdiff ))
			threatbar:SetValue(threatdiff)
			threatbar:SetBackdropColor(1, .5, 0, .4)
		end	
	elseif status == 3
	then
		--icon:SetTexCoord(GetTexCoordsForRoleSmallCircle("TANK"))
		font2:SetText("AGGRO!")
		threatbar:SetValue(threatpct)
		threatbar:SetStatusBarColor(1, 0, 0, 1)
		--frame:SetBackdropBorderColor(1, 0, 0, 1)
		if highThreat ~= 0
		then
			threatValuediff = ((playerThreatValue - unitThreatValue) / 100000 )
			threatdiff = (100 - highThreat)
			font1:SetText(string.format("|c%s%s|r", highUnitColor, highUnit ))
			font2:SetText(string.format("%2.1fk | %s %%", threatValuediff, threatdiff ))
			threatbar:SetValue(threatdiff)
			threatbar:SetBackdropColor(1, 0, 0, .4)
		end
	end
end

local function eventHandler(self, event, ...)
	if event == "PLAYER_LOGIN" then
		if texture and font then
			threatbar:SetStatusBarTexture(texture)
			font1:SetFont(font, 12)
			font2:SetFont(font, 12)
		else
			font1:SetFont("Fonts\\FRIZQT__.TTF", 12)
			threatbar:SetStatusBarTexture("Interface\\TARGETINGFRAME\\UI-StatusBar")
			font2:SetFont("Fonts\\FRIZQT__.TTF", 12)
		end
	else
		UpdateDisplay()
	end
end
threatbar:SetScript("OnEvent", eventHandler)


local function SetTexture(button, arg1)	
	threatbar:SetStatusBarTexture(arg1)
	texture = arg1
end

local function SetFont(button, arg1)
	font1:SetFont(arg1, 12)
	font2:SetFont(arg1, 12)
	font = arg1
end

 -- creating test data structure
 local Test1_Data = {
   ["Textures"] = {
     [1] = {["name"] = "Status Bar";
			["path"] = "Interface\\TARGETINGFRAME\\UI-StatusBar";
			["function"] = SetTexture;},
     [2] = {["name"] = "Barfill 2"; 
			["path"] = "Interface\\TARGETINGFRAME\\BarFill2";
			["function"] = SetTexture;},
	 [3] = {["name"] = "Character Skills"; 
			["path"] = "Interface\\PaperDollInfoFrame\\UI-Character-Skills-Bar";
			["function"] = SetTexture;},
	 [4] = {["name"] = "Raid HP"; 
			["path"] = "Interface\\RAIDFRAME\\Raid-Bar-Hp-Fill";
			["function"] = SetTexture;},
	 [5] = {["name"] = "Raid Resource"; 
			["path"] = "Interface\\RAIDFRAME\\Raid-Bar-Resource-Fill";
			["function"] = SetTexture;},		
   },
   ["Fonts"] = {
     [1] = {["name"] = "Arial Narrow"; 
			["path"] = "Fonts\\ARIALN.TTF";
			["function"] = SetFont;},
     [2] = {["name"] = "Friz Quadrata TT"; 
			["path"] = "Fonts\\FRIZQT__.TTF";
			["function"] = SetFont;},
	 [3] = {["name"] = "Morpheus"; 
			["path"] = "Fonts\\MORPHEUS.TTF";
			["function"] = SetFont;},
	 [4] = {["name"] = "Skurri"; 
			["path"] = "Fonts\\SKURRI.TTF";
			["function"] = SetFont;},	
   }
 }
 
  -- menu create function
 function Test1_DropDown_Initialize(self,level)
   level = level or 1;
   if (level == 1) then
     for key, subarray in pairs(Test1_Data) do
       local info = UIDropDownMenu_CreateInfo();
       info.hasArrow = true; -- creates submenu
       info.notCheckable = true;
       info.text = key;
       info.value = {
         ["Level1_Key"] = key;
       };
       UIDropDownMenu_AddButton(info, level);
     end -- for key, subarray
   end -- if level 1

   if (level == 2) then
	-- getting values of first menu
     local Level1_Key = UIDROPDOWNMENU_MENU_VALUE["Level1_Key"];
     subarray = Test1_Data[Level1_Key];
     for key, subsubarray in pairs(subarray) do
       local info = UIDropDownMenu_CreateInfo();
       info.hasArrow = false; -- no submenues this time
       --info.notCheckable = true;
       info.text = subsubarray["name"];
       -- use info.func to set a function to be called at "click"
	   info.func = subsubarray["function"]
	   info.arg1 = subsubarray["path"]
	   if info.arg1 == font or info.arg1 == texture then 
		info.checked = true
	   else
		info.checked = false
	   end
	
       info.value = {
         ["Level1_Key"] = Level1_Key;
         ["Sublevel_Key"] = key;
       };
       UIDropDownMenu_AddButton(info, level);
     end -- for key,subsubarray
   end -- if level 2
 end -- function Test1_DropDown_Initialize


 
local dropdown = CreateFrame("Frame", "Test_DropDown", threatbar, "UIDropDownMenuTemplate");
UIDropDownMenu_Initialize(dropdown, Test1_DropDown_Initialize, "MENU");

threatbar:SetScript("OnMouseDown", function(s, button) 	
	if button == 'RightButton' then
		ToggleDropDownMenu(1, nil, dropdown, threatbar, 0, 0)
	end
end)